﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Map;

namespace MeasurePolylines
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private bool initialized;
        private MapPolyline polyline;

        public MainWindow()
        {
            InitializeComponent();

            this.radMap.InitializeCompleted += new EventHandler(radMap_InitializeCompleted);
        }

        private void radMap_InitializeCompleted(object sender, EventArgs e)
        {
            if (!this.initialized)
            {
                this.initialized = true;

                this.polyline = new MapPolyline()
                {
                    Points = new LocationCollection(),
                    Stroke = new SolidColorBrush(Colors.Brown),
                    StrokeThickness = 3
                };

                this.informationLayer.Items.Add(this.polyline);
            }
        }

        private void radMap_MapMouseClick(object sender, Telerik.Windows.Controls.Map.MapMouseRoutedEventArgs eventArgs)
        {
            this.polyline.Points.Add(eventArgs.Location);
            this.CalculateDistance();
        }

        private void CalculateDistance()
        {
            if (this.polyline.Points.Count > 1)
            {
                double distance = 0;
                for (int i = 0; i < this.polyline.Points.Count - 1; i++)
                {
                    distance += this.GetDistance(this.polyline.Points[i], this.polyline.Points[i + 1]);
                }

                ToolTipService.SetToolTip(this.polyline, string.Format("The distance is {0:F0} meters.", distance * 1000d));
            }
        }

        private double GetDistance(Location location1, Location location2)
        {

            LocationRect rect = new LocationRect(location1, location2);

            rect.MapControl = this.radMap;

            double distance = Math.Sqrt(rect.Width * rect.Width + rect.Height * rect.Height);

            return distance;

        }
    }
}
